Desolation = CreateFrame("Frame","Desolation")

Desolation:SetScript("OnEvent", function(self, event, ...)
	self[event](self, event, ...)
end)

Desolation:RegisterEvent("ADDON_LOADED")
function Desolation.ADDON_LOADED(self, event, addon)
    if addon ~= "Desolation" then return end
    if GetLocale() == "ruRU" then
        Desolation.TooltipHook()
        Desolation.ChatHook()
    end
--~     local blockTaintPopup = false
--~     if blockTaintPopup then
--~         UIParent:UnregisterEvent("ADDON_ACTION_FORBIDDEN")
--~ 		UIParent:UnregisterEvent("ADDON_ACTION_BLOCKED")
--~     end
end

function plaingsub (s, p, r)
    p = gsub(p, '(%W)', '%%%1')
    return gsub(s, p, r)
  end

function Desolation.ChatHook()
    Desolation.OriginalChatFrame_MessageEventHandler = ChatFrame_MessageEventHandler
    Desolation.ChatFrame_OnEvent = ChatFrame_OnEvent

--~     ChatFrame_MessageEventHandler
    ChatFrame_OnEvent = function (self, event, text, ...)
        if text then
        local newline = text
        for linkType, linkID, linkName in string.gmatch(text,"|c%x+|H(%w+):(%d+).-|h%[(.-)%]|h|r") do 
--~             print(gsub(text, "\124", "\124\124"))
            if Desolation[linkType] then
                local eng = Desolation[linkType][tonumber(linkID)]
                if eng then
                    newline = plaingsub(newline, linkName, eng)
                end
            end
        end
        text = newline
        end
--~         Desolation.OriginalChatFrame_MessageEventHandler(self, event, text, ...)
        Desolation.ChatFrame_OnEvent(self, event, text, ...)
    end
    
    Desolation.ChatFrameEditBox_Insert = ChatFrameEditBox.Insert
    ChatFrameEditBox.Insert = function (self, link)
        linkType, linkID, linkName = string.match(link,"|c%x+|H(%w+):(%d+).-|h%[(.-)%]|h|r")
--~         print (linkType.."   "..linkID.."    "..linkName)
        if linkID and Desolation[linkType] then
            local eng = Desolation[linkType][tonumber(linkID)]
            link = plaingsub(link, linkName, eng)
        end
        return Desolation.ChatFrameEditBox_Insert(self, link)
    end
end


local RestoreTip = function(self)
    local itemNameString = getglobal(self:GetName().."TextLeft1")
    itemNameString:SetPoint("TOPLEFT",self,"TOPLEFT",10,-10)
    local enline = getglobal(self:GetName().."DesolationString")
    if enline then
        enline:Hide()
    end
end
--~ local gap = 5
function Desolation.TooltipHook()
    Desolation.gimmeLink = function(self, link, altlink)    
        if not link then return RestoreTip(self) end
        local linkType, linkID = string.match(link,"H?(%w+):(%d+).-")
        if altlink then linkType, linkID = string.match(link,"(%w+):(%d+).-") end
        
        local tip = getglobal(self:GetName().."DesolationTooltip")
        
--~         print (linkID)
--~         print (linkType)
--~         print (Desolation[linkType][tonumber(linkID)])
        if not linkID or not Desolation[linkType] or not Desolation[linkType][tonumber(linkID)] then
            if tip then tip:Hide() end
            return
--~             RestoreTip(self)
        end
        
        if not tip then
            tip = CreateFrame("Frame",self:GetName().."DesolationTooltip", self)
            tip:SetBackdrop({
                bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", 
                edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, 
                insets = { left = 5, right = 5, top = 5, bottom = 5 }
            })
            tip:SetBackdropColor(0.09,0.09,0.18)
            local enline = tip:CreateFontString("$parentText","ARTWORK","GameTooltipHeaderText")
            enline:SetPoint("TOPLEFT",tip,"TOPLEFT",10,-10)
            enline:SetPoint("BOTTOMRIGHT",tip,"BOTTOMRIGHT",-10,10)
--~             enline:SetAllPoints(tip)
            
            tip:SetPoint("BOTTOMLEFT",self,"TOPLEFT",0,1)
            tip:SetPoint("BOTTOMRIGHT",self,"TOPRIGHT",0,1)
            tip:SetHeight(32)
        end
        
        local enline = getglobal(tip:GetName().."Text")
--~         enline:SetPoint("TOPLEFT",self,"TOPLEFT",10,-10)
--~         local itemNameString = getglobal(self:GetName().."TextLeft1")
--~         itemNameString:SetPoint("TOPLEFT",enline,"BOTTOMLEFT",0,-gap)
        tip:Show()
        
--~         self:SetHeight(self:GetHeight() + enline:GetHeight() + gap)
        local eng = Desolation[linkType][tonumber(linkID)]
        local r,g,b,a = getglobal(self:GetName().."TextLeft1"):GetTextColor()
        enline:SetTextColor(r,g,b,a)
        enline:SetText(eng)
    end


--~     local methods = getmetatable(CreateFrame("GameTooltip","DesolTip",nil,"GameTooltipTemplate")).__index
  local tooltips = { getmetatable(CreateFrame("GameTooltip","DesolTip",nil,"GameTooltipTemplate")).__index,    GameTooltip }
    for _,methods in ipairs(tooltips) do
    hooksecurefunc(methods, 'Hide', function(self)
        local tip = getglobal(self:GetName().."DesolationTooltip")
        if tip then tip:Hide() end
    end)
    
    hooksecurefunc(methods, 'SetHyperlink', function(self, link)
        Desolation.gimmeLink(self, link)
    end)
--~     GameTooltip:SetBagItem(container, slot)
    hooksecurefunc(methods, 'SetBagItem', function(self, container, slot)
        Desolation.gimmeLink(self, GetContainerItemLink(container, slot))
    end)
--~     GameTooltip:SetLootItem(slot)
    hooksecurefunc(methods, 'SetLootItem', function(self, slot)
        Desolation.gimmeLink(self, GetLootSlotLink(slot))
    end)
--~     GameTooltip:SetInboxItem(mailID, attachmentIndex)   GetInboxItemLink(mailID, attachmentIndex)
    hooksecurefunc(methods, 'SetInboxItem', function(self, mailID, attachmentIndex)
        Desolation.gimmeLink(self, GetInboxItemLink(mailID, attachmentIndex))
    end)
--~     GameTooltip:SetInventoryItem("unit", slot [, nameOnly])   GetInventoryItemLink("unit", slot)
    hooksecurefunc(methods, 'SetInventoryItem', function(self, unit, slot)
        Desolation.gimmeLink(self, GetInventoryItemLink(unit, slot))
    end)
--~     GameTooltip:SetMerchantItem(merchantIndex)    GetMerchantItemLink(index)
    hooksecurefunc(methods, 'SetMerchantItem', function(self, index)
        Desolation.gimmeLink(self, GetMerchantItemLink(index))
    end)
    
    
    hooksecurefunc('SetItemRef', function(link, text, button)
        Desolation.gimmeLink(ItemRefTooltip, link, true)
    end)
--~     SetItemRef(link, text, button)
    
  end
    
end